// word.c

#include "combo.h"

#define begin {
#define end   }


//==================================
// wordScrambleDir
//
// Prints directions for the word scramble on screen.  When start
// is pressed,it erases the screen to prepare for initialization and
// game play.
void wordScrambleDir(void)
begin
	switch(drawingFrame)
	begin
		case(0):
		begin
			sprintf(screenString,"TASK 1:");
			video_putsmalls(4,15,screenString);
		     
			sprintf(screenString,"UNDERSTANDING YOUR TA");
			video_putsmalls(4,25,screenString);
		     
			sprintf(screenString,"UNSCRAMBLE THE FOLLOWING WORDS");
			video_putsmalls(4,40,screenString); 
		     
			drawingFrame=1;
			break;
		end
		case(1):
		begin

			sprintf(screenString,"BUTTON A: SELECTS LETTER");
			video_putsmalls(4,52,screenString);
		     
			sprintf(screenString,"BUTTON B: CLEARS LAST LETTER");
			video_putsmalls(4,60,screenString); 
		     
			sprintf(screenString,"BUTTON C: ENTERS WORD");
			video_putsmalls(4,68,screenString);
		
			drawingFrame=2;
			break;
		end
		case(2):
		begin
		   	if(button==startButton)
			begin
				video_putsmalls(4,15,blanks);

				video_putsmalls(4,25,longBlanks);

				video_putsmalls(4,40,longBlanks); 
     		     
				//initialize variables
				button=0;
            	wordsUsedIndex = 0;
            	wordGuessIndex = 0;
            	lastScrambleIndex = 0;
				WSCount=0;
				wordNumber=seed%10;//select first word
				drawingFrame = 3;
			end
			break;
		end
		case(3):
		begin
			video_putsmalls(4,52,longBlanks);

	     	video_putsmalls(4,60,longBlanks); 

	     	video_putsmalls(4,68,longBlanks);
     		     
 			drawingFrame=4;
     		break;
		end
		case(4):
		begin
			sprintf(screenTitle,"Math 192");
            video_puts(36,3,screenTitle);
            		
            levelState = Init;
            drawingFrame=0;
            break;
		end
	end
end

//==================================
// wordScrambleInit
//
// Initializes word scramble level by drawing the chalkboard and initializing
// point values and time limits for each word
void wordScrambleInit(void)
begin     
  	switch(drawingFrame)
  	begin
  		case(0):
  		begin
            //draw chalkboard
            video_box(10,20,115,70,1);
             	               
			//initialize chalkboard cursor positions	  
			chalkCursorX = 17;
			chalkCursorY = 50;
              
			drawingFrame=1;//set drawingFrame to 1 so rest of frame is drawn
              
			//increment WSCount (# of Word Scrambles performed)
			WSCount++; 
            break;
    	end
    	case(1):
    	begin
               	video_box(11,21,114,69,1);//more chalkboard      
          	
          		gameTime = 45-5*((WSCount-1)>>1); //set game time
          		totalCredits = 4+((WSCount-1)>>2);
          	/*
          		WSCount	time	totalCredits
          		1     	45			4
          		2			45			4
          		3       	40			4
          		4       	40			4
          		5       	35			5
          		6       	35			5
          		7       	30			5
          		8       	30			5
          		9       	25			6
          		10      	25			6          		
          	*/
          		drawingFrame = 2; //reset drawingFrame
          		wordGuessIndex = 0;
               	lastScrambleIndex = 0;
          		break;
          	end 
          	case(2):
    		begin
             	video_box(13,23,112,67,1);//more chalkboard
             	
				//draw a blank for the first letter on the chalkboard
				video_line(chalkCursorX,chalkCursorY,chalkCursorX+5,chalkCursorY,1);  
            	
				//set showWord high (tells wordScramble() to display new word)            
				showWord = 1;
            		
				//initialize placement of letter selection box
				wordCursorX = 2;
				wordCursorY = 77;
	
				drawingFrame=0;
				levelState=Game; //set level1State to WSGame to begin gameplay
				break;
			end        
	end
end//wordScrambleInit


//==================================
// wordAlreadyUsed
//
// returns 1 if word has been used already
char wordAlreadyUsed(char num)
begin
	char i;
	
	for (i=0; i<(wordsUsedIndex); i++)
	begin
		if (wordsUsed[i]==num) return 1;
	end
	return 0;
end

//==================================
// nextCursorPosLeft
//
// Moves the cursor (box) one letter to the left.  Wraps around to
// the rightmost letter if currently on leftmost.
void nextCursorPosLeft(void)
begin
	char i;
	
	prevWordCursorX = wordCursorX;//store the current cursor position
        	
  	//if the cursor (box) is on the leftmost letter
	if (wordCursorX == 2)
		//move the cursor to the rightmost letter (cursor wraps around)
        wordCursorX = wordCursorX+12*(wordLength-1);
	//otherwise just move one letter to the left
	else wordCursorX-=12;
     
	//convert wordCursorX to an index to the array wordScrambled
	i = (wordCursorX-2)/12;  	
        
	//while the next space over is blank (letter already used)	
   	while (wordScrambled[i]==' ')
   	begin
   		//if the cursor (box) is on the leftmost letter
		if (wordCursorX == 2)
          		//move the cursor to the rightmost letter (cursor wraps around)
             		wordCursorX = wordCursorX+12*(wordLength-1);
		//otherwise just move one letter to the left
        else wordCursorX-=12;

        i = (wordCursorX-2)/12;
   	end
 end
 
//==================================
// nextCursorPosRight
//
// Moves the cursor (box) one letter to the right.  Wraps around to the
// leftmost letter if currently on rightmost.
void nextCursorPosRight(void)
begin
	char i;
 		
	prevWordCursorX = wordCursorX;//store the current cursor position
          
	//if the cursor (box) is on the rightmost letter
	if (wordCursorX == 2+12*(wordLength-1))
		//move the cursor to the leftmost letter (cursor wraps around)
		wordCursorX = 2;
	//otherwise just move one letter to the right
	else wordCursorX+=12;
        	
	//convert wordCursorX to an index to the array wordScrambled
 	i = (wordCursorX-2)/12;  	
        
	//while the next space over is blank (letter already used)		
	while (wordScrambled[i]==' ')
        begin
		//if the cursor (box) is on the rightmost letter
             	if (wordCursorX == 2+12*(wordLength-1))
 			//move the cursor to the leftmost letter (cursor wraps around)
             		wordCursorX = 2;
             	//otherwise just move one letter to the right
             	else wordCursorX+=12;

             	i = (wordCursorX-2)/12;
 	end
 end
 
//==================================
// wordCorrect
//
// Checks to see if the word guessed matches the word selected
// returns 1 for a match, 0 otherwise
char wordCorrect(void)
begin
	char i, correct=1;
	
	if (wordGuessIndex != wordLength) return 0;
	
	for (i=0; i<wordLength-1; i++)
	begin
		correct = correct & (wordSelected[i]==wordGuessed[i]);
		wordSelected[i]=0;
		wordGuessed[i]=0;
	end
	
	return correct;
end
		

/*
	Button Functions:
	left/right = mores selection box left/right
	A = chooses letter in selection box
	B = erases last letter
	C = indicates user is done
*/
//==================================
// wordScramble
//
// Takes care of game play.
// If a new word is to be shown, it randomly selects an unused word, scrambles
// it and shows it on the screen.  The timer is decremented each second while the
// game is running.  If time runs out, "TIMES UP" is displayed on screen and no
// credits are rewarded.  Otherwise, user button presses are dealt with.  If the
// user guesses the correct word, credits are rewarded and preparation for the next
// word or level begins.
void wordScramble(void)
begin
	char i=0,j=0,selectedLetter[2],temp[10];

	//if we are to begin a new word scramble...
	if (showWord)
	begin 
		switch (drawingFrame)
		begin
		    	case(0):
				begin
                     
	               	wordLength=0;//reset wordLength	
	               	
	               		//for each letter in the chosen word
	               	for (i=0; wordMatrix[wordNumber][i] != 0; i++)
	               	begin
	               			//store the letter in wordSelected
	               			wordSelected[i] = wordMatrix[wordNumber][i];
	               			wordScrambled[i] = 0; //reset wordScrambled
	               			wordGuessed[i] = 0; //reset wordGuessed
	               			//increment wordLength to get length of selected word
	               			wordLength++;
	               		end
	               		
	               		if (i<maxWordLength)
	               		begin
	               			wordGuessed[i]=0; 
	               			wordScrambled[i]=0;
	               		end
	               	
	               		//init software timer
            			time=0;
            			timer=gameTime;
            		
            			drawingFrame=2;

                   		break;
             		end
             		case(2):
             		begin
  				//for each letter in the chosen word
	               		for (i=0; i<wordLength; i++)
	               		begin                    
	               			//create a random number from 0 to length-1
	               			j=(rand()%wordLength);

	               			//while that slot of wordScrambled contains a letter, increment j
	               			while (wordScrambled[j] != 0 || j==i)
	               	 		begin
	              				j = (j+1)%wordLength;
	               			end
	               			//fill the empty slot of wordScrambled with the current letter
	               			wordScrambled[j] = wordSelected[i];
	               		end
	               	
	               		//print the scrambled word on screen
	               		video_putsSpaces(4,79,wordScrambled);
	               	
	               		//draw a box around the first letter
	               		video_box(wordCursorX,wordCursorY,wordCursorX+8,wordCursorY+10,1);
	               		drawingFrame=0;
	               		showWord = 0;
                   		break;
              		end
              		default: break;
		end//switch
   	end//if(showWord)
   	else
   	begin 
   		//update the second clock
          	//if time exceeds 59 (frames), one second has passed
          	if (++time>59 && timer!=0)
          	begin
			time=0;//reset time 
			timer--;//decrement the timer
			sprintf(timerString,"%05d",timer);//make the timer into a string
			video_putsmalls(104,92,timerString);//and display it on the screen
		end

		timesUp = (timer==0);
          
		if (timesUp)
          	begin 
          		switch(drawingFrame)
          		begin
          			case(0):
          			begin
          				video_putsSpaces(4,79,blanks);
               				drawingFrame = 1;
          				break;
          			end
          			case(1):
          			begin
          				video_puts(17,chalkCursorY-8,blanks);
               				drawingFrame = 2;
          				break;
          			end
          			case(2):
          			begin
               				video_box(wordCursorX,wordCursorY,wordCursorX+8,wordCursorY+10,0);
               				drawingFrame = 3;
          				break;
          			end
          			case(3):
          			begin
					video_putsmalls(20,chalkCursorY-8,timesUpLabel);
               				drawingFrame = 4;
					break;
             			end
             			case(4):
          			begin
          				//erase the box
               				video_box(chalkCursorX,chalkCursorY,chalkCursorX+5,chalkCursorY,0);
               				drawingFrame = 0;
               				levelState=Check;
               				displayCount=0;
             			end
             			default: break;
			end//switch
          	end//timesUp
          	else
          	begin
          		switch(button)
          		begin 
                  		case(leftButton)://if the left arrow has been pressed
                  		begin
                  			if(wordGuessIndex==wordLength) break;

                  			nextCursorPosLeft();             	
                  			//erase the previous box	
                  			video_box(prevWordCursorX,wordCursorY,prevWordCursorX+8,wordCursorY+10,0);
                  			//draw the new box
                  			video_box(wordCursorX,wordCursorY,wordCursorX+8,wordCursorY+10,1);
                  			break;
                  		end 
                  		case(rightButton)://if the right arrow has been pressed
                  		begin
                  			if(wordGuessIndex==wordLength) break;
                  	
					nextCursorPosRight();                
                  			//erase the previous box
                  			video_box(prevWordCursorX,wordCursorY,prevWordCursorX+8,wordCursorY+10,0);
                  			//draw the new box
                  			video_box(wordCursorX,wordCursorY,wordCursorX+8,wordCursorY+10,1);
                  			break;
                  		end
                  		case(CButton)://enter 
                  		begin  
                  			if(wordGuessIndex!=wordLength) break;
                  		
					//check to see if word matches
                  			if (wordCorrect())
                  			begin
                  				video_putsmalls(20,57, correctLabel);
                  				credits+=totalCredits;
  						sprintf(creditsString,"%03d",credits);
  						video_putsmalls(4,92,creditsString);
                  			end
                  			else
                  			begin
                  				video_putsmalls(20,57, incorrectLabel);
                  			end

                  			drawingFrame = 0;
                  			levelState=Check;
                  			displayCount=0;

                  			//erase the box
                       			video_box(wordCursorX,wordCursorY,wordCursorX+8,wordCursorY+10,0); 
                       			//erase the blank
          				video_line(chalkCursorX,chalkCursorY,chalkCursorX+5,chalkCursorY,0);               		
                  			break;
                  		end
                  		case(BButton)://clear last
                  		begin  
                  			if (wordGuessIndex==0) break;
                  		
                  			//put the last selected letter back in the scrambled word
                  			wordScrambled[lastScramblePos[--lastScrambleIndex]] = wordGuessed[--wordGuessIndex];
                  			//and delete it from the word guessed
                  			wordGuessed[wordGuessIndex]=0;
                  		
                  			selectedLetter[0] = wordScrambled[lastScramblePos[lastScrambleIndex]];
          				selectedLetter[1]=0;
     					video_puts((12*lastScramblePos[lastScrambleIndex])+4,wordCursorY+2,selectedLetter);
     				
     					prevWordCursorX = wordCursorX;
     					wordCursorX = (12*lastScramblePos[lastScrambleIndex])+2;

     					//erase the previous box
                       			video_box(prevWordCursorX,wordCursorY,prevWordCursorX+8,wordCursorY+10,0);
                       			//draw the new box
                       			video_box(wordCursorX,wordCursorY,wordCursorX+8,wordCursorY+10,1);
                       	
                  			//erase blank line
                  			video_line(chalkCursorX,chalkCursorY,chalkCursorX+5,chalkCursorY,0);
                  			chalkCursorX-=6;
                  		
                  			selectedLetter[0] = ' ';
          				selectedLetter[1]=0;
     					video_puts(chalkCursorX,chalkCursorY-8,selectedLetter);
     				
                  			//draw new blank line
                  			video_line(chalkCursorX,chalkCursorY,chalkCursorX+5,chalkCursorY,1);
                  			break;
                  		end
                  		case(AButton): 
                  		begin  
                  			switch(drawingFrame)
                  			begin
                  				case(0):
                  				begin 
                  					//do nothing if no more letters
							if(wordGuessIndex==wordLength) break;

               						//draw a blank for the next letter on the chalkboard
                    					video_line(chalkCursorX,chalkCursorY,chalkCursorX+5,chalkCursorY,0);
                    			
                    					//convert wordCursorX to an index into wordScrambled
							i = (wordCursorX-2)/12;

							//store the letter at that index     			
                    					selectedLetter[0] = wordScrambled[i];
                    					selectedLetter[1]=0; //so only one letter displayed
							//display it on screen
               						video_puts(chalkCursorX,chalkCursorY-8,selectedLetter);
               				
               						//store this letter in wordGuessed
							wordGuessed[wordGuessIndex++] = wordScrambled[i];

							//store the index so we can backspace correctly
               						lastScramblePos[lastScrambleIndex++] = i;

               						//update wordScrambled and display it
							wordScrambled[i]=' ';
               						video_putsSpaces(4,79,wordScrambled);	
               				
               						chalkCursorX+=6;
                    					video_line(chalkCursorX,chalkCursorY,chalkCursorX+5,chalkCursorY,1); 
                    			
                    					drawingFrame=1;
                    					break;
                   				end       
          					case(1):
          					begin
							//if no more letters
                    					if(wordGuessIndex==wordLength)
                    					begin
                    			   			//erase the box
                    			   			video_box(wordCursorX,wordCursorY,wordCursorX+8,wordCursorY+10,0);
                    			   			video_line(chalkCursorX,chalkCursorY,chalkCursorX+5,chalkCursorY,0);

                    						break;
                    					end

                    					nextCursorPosRight();
                
                                 			//erase the previous box
                                 			video_box(prevWordCursorX,wordCursorY,prevWordCursorX+8,wordCursorY+10,0);
                                 			//draw the new box
                                 			video_box(wordCursorX,wordCursorY,wordCursorX+8,wordCursorY+10,1);
               				  
               						drawingFrame=0;
               						button=0;//reset buttonFlag since we've taken care of it
                    					break;
                   				end
                   			end//switch
                  			break;
                  		end//AButton
                  		default: break;
          		end//switch(button)

          		if (button!=AButton) button=0;//reset buttonFlag since we've taken care of it
          	end
     	end//else
end 

//============================================
// wordScrambleStateMachin
//
// Ensures that this level flows properly from display of directions
// through gameplay to the end of the level.
void wordScrambleStateMachine(void)
begin
	switch(levelState)
	begin
		case(Dir):
		begin
			wordScrambleDir();
			break;
		end 
		case(Init):
		begin
			wordScrambleInit(); 
			break;
		end
		case(Game):
		begin
			wordScramble();
			break;
		end
		case(Check):
		begin
			//display times up, correct or incorrect message for a second or so
			if(++displayCount > 100) levelState=ShowCredits;
			break;
		end
		case(ShowCredits):
		begin
			switch(drawingFrame)
		     	begin 
		     		case(0):
		     		begin
          		     		video_puts(17,chalkCursorY-8,blanks); 
          		     		wordNumber++;                      	
								drawingFrame=1;  
                       			break;
                 		end 
                 		case(1):
		     		begin
                       			video_putsmalls(20,57, blanks);
                         		drawingFrame=2; 
                         		break;
                 		end 
                 		case(2):
		     		begin
                       			video_putsmalls(16,chalkCursorY-8,startLabel);
                       			drawingFrame=0;
                       			levelState=Ready;
                       			break;
                 		end 
               		end
			break;
		end
		case(Ready):
		begin
			//if start pressed, erase screen in preparation for next level
			if(button==startButton)
			begin
				sprintf(screenString,"                       ");
    				video_putsmalls(16,chalkCursorY-8,screenString);
				
				if (WSCount < 10)
				begin
     					levelState=Init;
     					drawingFrame=0;
     					displayCount = 0;
     					button=0;
				end
				else
				begin
					switch(drawingFrame)
					begin 
						case(0):
						begin
							//erase chalkboard
  							video_box(10,20,115,70,0);
							drawingFrame = 1;
							break;
						end
						case(1):
						begin
							video_box(11,21,114,69,0);
             		    				drawingFrame=2;
             		    				songState=none;
							noteIndex=1;
  							break;
  						end
  						case(2):
  						begin
             		    				video_box(13,23,112,67,0);
             		    				sprintf(screenTitle,"        ");
             						drawingFrame=3;
             		    				break;
        					end 
        					case(3):
  						begin
             		    				video_puts(36,3,screenTitle);
             						drawingFrame=0;
             						yearState=soph;
							levelState=Dir;
							button=0;
             		    				break;
        					end
             				end
				end//WSCount > 10
			end//start pressed
			break;
		end//Ready
		default: break;
	end//switch
end//state machine